Summary: AFS PAG and AFS tokens on login
Name: pam_afs_session
Version: 2.5
Release: 0%{?dist}
License: MIT
Group: System Environment/Base
URL: http://www.eyrie.org/~eagle/software/pam-afs-session/
Source: http://archives.eyrie.org/software/afs/pam-afs-session-%{version}.tar.gz
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: pam_krb5
Requires: openafs augeas
BuildRequires: pam-devel%{?_isa}
BuildRequires: krb5-devel%{?_isa}
BuildRequires: openafs-devel%{?_isa}
BuildRequires: openafs
%description
pam-afs-session is a PAM module intended for use with a Kerberos v5 PAM module
to obtain an AFS PAG (Process Authentication Group) and AFS tokens on login. It
puts every new session in a PAG regardless of whether it was authenticated with
Kerberos and runs a configurable external program to obtain tokens.

%define pamdir /%{_lib}/security

%prep
%setup -q -n pam-afs-session-%{version}
# remove non-redhat examples
find examples -mindepth 1 -maxdepth 1 -not -name "redhat" -exec rm -rf {} ';'

%build
%configure --libdir=/%{_lib} --with-aklog=%{_bindir}/aklog
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
rm -f $RPM_BUILD_ROOT%{pamdir}/*.la

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%{pamdir}/pam_afs_session.so
%{_mandir}/man5/pam_afs_session.5.gz
%doc LICENSE NEWS README TODO examples

%post
# If Augeas is installed
if [[ -x /usr/bin/augtool ]]; then
    # if Augeas has the pam lense
    if [[ -e /usr/share/augeas/lenses/dist/pam.aug ]]; then
        if [[ `grep session /etc/pam.d/system-auth |grep pam_afs_session.so` == '' ]]; then
            cat > /tmp/$$.tmp <<EOF
ins 999 after /files/etc/pam.d/system-auth/*[type = 'session'][module = 'pam_krb5.so']
set /files/etc/pam.d/system-auth/999/type session
set /files/etc/pam.d/system-auth/999/control required
set /files/etc/pam.d/system-auth/999/module pam_afs_session.so
set /files/etc/pam.d/system-auth/999/argument[1] tokens
set /files/etc/pam.d/system-auth/999/argument[2] minimum_uid=100

save

EOF
            augtool -b < /tmp/$$.tmp >/dev/null 2>&1
            rm -f /tmp/$$.tmp
        fi
        if [[ `grep auth /etc/pam.d/system-auth |grep pam_afs_session.so` == '' ]]; then
            cat > /tmp/$$.tmp <<EOF
ins 01 after /files/etc/pam.d/system-auth/*[type = 'auth'][module = 'pam_krb5.so']
set /files/etc/pam.d/system-auth/01/type auth
set /files/etc/pam.d/system-auth/01/control optional
set /files/etc/pam.d/system-auth/01/module pam_afs_session.so
set /files/etc/pam.d/system-auth/01/argument[1] tokens
set /files/etc/pam.d/system-auth/01/argument[2] minimum_uid=100

save

EOF
            augtool -b < /tmp/$$.tmp >/dev/null 2>&1
            rm -f /tmp/$$.tmp
        fi
    fi
fi

%preun
mv -f /etc/pam.d/system-auth /etc/pam.d/system-auth.rpmbakup
grep -v pam_afs_session.so /etc/pam.d/system-auth.rpmbakup > /etc/pam.d/system-auth
chmod --reference=/etc/pam.d/system-auth.rpmbakup /etc/pam.d/system-auth


%changelog
* Wed Nov 28 2012 Pat Riehecky <riehecky@fnal.gov> - 2.5-0
- New upstream release
- augeas is now required

* Tue Aug 16 2011 Pat Riehecky <riehecky@fnal.gov> - 2.4-2
- Added %post script (using augeas to load the module if augeas is installed)
- Added %preun script to remove the module from PAM before removing from system
- Added build dep openafs
- Added build dep openafs-devel
- Added requires openafs

* Thu Jun 9 2011 Ken Dreyer <ktdreyer@ktdreyer.com> - 2.4-1
- New upstream release.

* Thu Mar 17 2011 Ken Dreyer <ktdreyer@ktdreyer.com> - 2.2-4
- configure --with-aklog. Your aklog binary better follow the FHS.

* Thu Mar 17 2011 Ken Dreyer <ktdreyer@ktdreyer.com> - 2.2-3
- add dist tag.

* Sun Mar 05 2011 Ken Dreyer <ktdreyer@ktdreyer.com> - 2.2-2
- modify source's examples folder in prep stage

* Sat Mar 05 2011 Ken Dreyer <ktdreyer@ktdreyer.com> - 2.2-1
- New upstream release.
- Only include redhat docs.

* Tue Mar 02 2011 Ken Dreyer <ktdreyer@ktdreyer.com> - 2.1-3
- Rename pam-afs-session to pam_afs_session

* Thu Feb 22 2011 Ken Dreyer <ktdreyer@ktdreyer.com> - 2.1-2
- Add %{?_isa} on the BuildRequires -devel packages

* Thu Feb 17 2011 Ken Dreyer <ktdreyer@ktdreyer.com> - 2.1-1
- Update to 2.1
- rpmlint fixes

* Fri Sep 10 2010 Ken Dreyer <ktdreyer@ktdreyer.com> - 1.7-1
- basic spec obtained from http://crcmedia.hpcc.nd.edu/wiki/index.php/Automatic_CRC/ND_AFS_cell_setup
- switch out Russ Allbery's pam-krb5 for RedHat's pam_krb5 in Requires
